/*
 * Created on October 21, 2005
 *
 */
package com.sunlabs.archsim.fleet.ships.adder_oob;

import com.sunlabs.archsim.base.simulation.Delay;

/*
 * Copyright � 2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 *  
 */

/**
 * @author mh193489
 *
 * Accumulator ship defaults.
 */
class AdderDefaults {

	private AdderDefaults() {}
	
	public static final String ADDER= "adder";
	public static final String ADD_DATA= "addData";

        public static final String IN1= "In1";
        public static final String ACK_IN1= "ackIn1";
        public static final String IN2= "In2";
        public static final String ACK_IN2= "ackIn2";
        public static final String OUT= "Out";
        public static final String ACK_OUT= "ackOut";

        
	public static String ADDER_DELAY= "adderOOBDelay";
        public static final Delay ADDER_DELAY_DEF= new Delay(10);

        public static String ACK_DELAY= "adderOOBAckDelay";
        public static final Delay ACK_DELAY_DEF= new Delay(10);
	
        public static final int OVERFLOW= Integer.MAX_VALUE;
        public static final int UNDERFLOW= Integer.MIN_VALUE;
        
        public static final int PLUS_INFINITY= 1;
        public static final int MINUS_INFINITY= -1;
        public static final int OOB= 0;
        
        
        public static final boolean logAddData= true;

} // class AdderDefaults
