/*
 * Copyright  2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 *  
 */

/*
 * Created on Feb 9, 2005
 *
 */
package com.sunlabs.archsim.tests.arbiter;

import com.sunlabs.archsim.base.simulation.Delay;
import com.sunlabs.archsim.gasp.Action;
import com.sunlabs.archsim.gasp.Function;


/**
 * @author ib27688
 *
 * Generate data items for the arbiter test.
 * Data items generated are consecutive integers, starting at zero.
 */
public class ArbiterTestSource extends Action {

	public ArbiterTestSource(String name, int start) {
		super(name);
		outputFunctions.put(ArbiterTestGlobal.DATA_OUT_TERMINAL_NAME, new GenerateData(start));
	} // FifoAction
	
	/** Generate new data items */
	private class GenerateData extends Function {

		private int next;
		
		public GenerateData(int start) {
			super("GenerateData");
			next= start;
			functionDelay= new Delay(10); // was 20
		}
		
		public Object value() {
			if (ArbiterTestGlobal.sourceDisplayGenerated) {
				director.journal("Source " + getName() 
						+ " generated " + next);
			}
			return new Integer(next++);	
		} // value
	} // PassData

} // ArbiterTestSource
